typedef enum{VT_SHORT, VT_FLOAT, VT_DOUBLE}TComiVarType;

typedef struct{
	unsigned short	wSubSysID;
	unsigned long	nInstance;
	char	szDevName[20];
	unsigned char	bDevCaps; // 0bit-A/D, 1bit-D/A, 2bit-DIO, 3bit-Counter,
	unsigned char	nNumAdChan, nNumDaChan, nNumDiChan, nNumDoChan, nNumCntrChan;
}TComiDevInfo;

typedef struct{
	unsigned short nNumDev;
	TComiDevInfo DevInfo[16];
}TComiDevList;

typedef struct{
	char szDate[13], szTime[10];  // Save start?? ??? ??? ?? ???
	int nNumChan; // Scan ?? ?
	int nChanList[64]; // Scan ?? ???
	int dmin, dmax;
	float vmin[64], vmax[64]; // Scan?? ? ??? A/D range
	unsigned long dwSavedScanCnt; // ??? ? Scan ?
}TScanFileHead;

typedef struct{
	float Ref, lim_h, lim_l;
	float Kp;
	float Td, Ti;
	int ch_ref, ch_ad, ch_da;
}TPidParams;

typedef struct _THelicalUserInfo{
	int c_map, z_axis; // Circualr interpolation axis map, Up/Down Axis
	double c_xcen, c_ycen; // Circular interpolation ceneter point
	int c_dir; // ????? ?? ??
	int c_num; // ?? ?(??? Arc ??)
	double c_la; // Last angle
	double z_dist;
}THelicalUserInfo;

 int COMILX_LoadDll(void);
 void COMILX_UnloadDll(void);
 HANDLE	(COMILX_LoadDevice) (unsigned short deviceID, unsigned long instance);
 void	(COMILX_UnloadDevice) (HANDLE hDevice);
 void	(COMILX_SetComiBus) (HANDLE hDevice, int bEnable, int bIsMaster);
 //___________ General A/D Functions _____________________________________________//
 void	(COMILX_AD_SetInputType) (HANDLE hDevice, int nInputMode);
 int	(COMILX_AD_SetRange) (HANDLE hDevice, int ch, float vmin, float vmax);
 int		(COMILX_AD_GetDigit) (HANDLE hDevice, int ch);
 float	(COMILX_AD_GetVolt) (HANDLE hDevice, int ch);
 //___________ Unlimited A/D Scan for LX10x _____________________________________________//
 long	(COMILX_US1_Start) (HANDLE hDevice, int nNumChannel, int *pChanList,
			unsigned int dwScanFreq, unsigned int nBufSize, int nTrsMethod);
 void	(COMILX_US1_Stop) (HANDLE hDevice, int bReleaseBuf);
 long	(COMILX_US1_ChangeScanFreq) (HANDLE hDevice, unsigned int dwScanFreq);
 void	(COMILX_US1_ResetCount) (HANDLE hDevice);
 short*	(COMILX_US1_GetBuffer) (HANDLE hDevice);
 unsigned long	(COMILX_US1_CurCount) (HANDLE hDevice);
 unsigned int	(COMILX_US1_SBPos) (HANDLE hDevice, int chOrder, unsigned long scanCount);
 int	(COMILX_US1_ReleaseBuf) (HANDLE hDevice);
 short	(COMILX_US1_RetrvOne) (HANDLE hDevice, int chOrder, unsigned long scanCount);
 unsigned long	(COMILX_US1_RetrvChannel) (HANDLE hDevice, int chOrder, unsigned long startCount, 
			int maxNumData, void *pDestBuf, TComiVarType VarType);
 unsigned int	(COMILX_US1_RetrvBlock) (HANDLE hDevice, unsigned int startCount, int maxNumScan, 
			void *pDestBuf, TComiVarType VarType);
 //___________ Unlimited A/D Scan for LX20x _____________________________________________//
 void	(COMILX_US2_SetTriggerEvent) (HANDLE hDevice, int nInputSource,
					int nEdgeType, int nTrgMode, float fAiRef, float fAiRefBand);
 double	(COMILX_US2_Start) (HANDLE hDevice, int nNumChannel, int *pChanList, unsigned int nScanFreq,
								   unsigned short nBufSizeGain, int bPauseAtBufFull);
 void	(COMILX_US2_Resume) (HANDLE hDevice);
 double	(COMILX_US2_ChangeScanFreq) (HANDLE hDevice, unsigned int dwScanFreq);
 unsigned long	(COMILX_US2_DmaCount) (HANDLE hDevice);
 int	(COMILX_US2_IsBufFull) (HANDLE hDevice);
 short*	(COMILX_US2_GetBuffer) (HANDLE hDevice, int chOrder);
 unsigned long	(COMILX_US2_RetrvChannel) (HANDLE hDevice, int chOrder, unsigned long startCount,
						int maxNumData, void *pDestBuf, TComiVarType VarType);
 void	(COMILX_US2_Stop) (HANDLE hDevice, int bReleaseBuf);
 int	(COMILX_US2_ReleaseBuf) (HANDLE hDevice);
 //___________ DIO Common __________________________________________________//
 void	(COMILX_DIO_SetUsage) (HANDLE hDevice, int usage);
 int		(COMILX_DIO_GetUsage) (HANDLE hDevice);
 //__________ D/I Functions ________________________________________________//
 int		(COMILX_DI_GetOne) (HANDLE hDevice, int ch);
 unsigned long	(COMILX_DI_GetAll) (HANDLE hDevice);
 unsigned long	(COMILX_DI_GetAllEx) (HANDLE hDevice, int nGroupIdx);
 //__________ D/O Functions ________________________________________________//
 void	(COMILX_DO_PutOne) (HANDLE hDevice, int ch, int status);
 void	(COMILX_DO_PutAll) (HANDLE hDevice, unsigned long dwStatuses);
 void	(COMILX_DO_PutAllEx) (HANDLE hDevice, int nGroupIdx, unsigned long dwStatuses);
 unsigned long	(COMILX_DO_GetOne) (HANDLE hDevice, int ch);
 unsigned long	(COMILX_DO_GetAll) (HANDLE hDevice);
 unsigned long	(COMILX_DO_GetAllEx) (HANDLE hDevice, int nGroupIdx);
 //__________ Serial Digital Input/Output Functions ________________________//
 int	(COMILX_SDIO_InitComm) (HANDLE hDevice);
 int	(COMILX_SDIO_CheckModule) (HANDLE hDevice, int nModuleNo);
 int	(COMILX_SDIO_SetDioUsage) (HANDLE hDevice, int nModuleNo, int nUsge);
 unsigned char	(COMILX_SDIO_ReadLowByte) (HANDLE hDevice, int nModuleNo);
 unsigned char	(COMILX_SDIO_ReadHighByte) (HANDLE hDevice, int nModuleNo);
 unsigned short	(COMILX_SDIO_ReadWord) (HANDLE hDevice, int nModuleNo);
 int	(COMILX_SDIO_WriteLowByte) (HANDLE hDevice, int nModuleNo, unsigned char bValue);
 int	(COMILX_SDIO_WriteHighByte) (HANDLE hDevice, int nModuleNo, unsigned char bValue);
 int	(COMILX_SDIO_WriteWord) (HANDLE hDevice, int nModuleNo, unsigned short wWord);
 //__________ D/A Functions ________________________________________________//
 int	(COMILX_DA_Out) (HANDLE hDevice, int ch, float volt);
 long	(COMILX_WFM_Start) (HANDLE hDevice, int ch, float *pDataBuffer, 
						unsigned int nNumData, unsigned int nPPS, int nMaxLoops);
 int	(COMILX_WFM_Reload) (HANDLE hDevice, int ch, float *pDataBuffer, unsigned int nNumData);
 long	(COMILX_WFM_RateChange) (HANDLE hDevice, int ch, unsigned long nPPS);
 long	(COMILX_WFM_GetCurPos) (HANDLE hDevice, int ch);
 long	(COMILX_WFM_GetCurLoops) (HANDLE hDevice, int ch);
 void	(COMILX_WFM_Stop) (HANDLE hDevice, int ch);

 //__________ Counter Functions ____________________________________________//
 unsigned long 	(COMILX_ReadCounter32) (HANDLE hDevice, int ch);
 void 	(COMILX_ClearCounter32) (HANDLE hDevice, int ch);

 //__________ Motion/Control Functions ____________________________________________//
 // Initialize functions //
 void (COMILX_MC_Reset) (HANDLE hDevice);
 void (COMILX_MC_ServoOn) (HANDLE hDevice, int nChannel, int bEnable);
 int	 (COMILX_MC_GetServoOn) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_SetBlockingMode) (HANDLE hDevice, int bBlocking);
 void (COMILX_MC_SetWindowHandle) (HANDLE hDevice, unsigned long hWnd);
 void (COMILX_MC_SetOutputMode) (HANDLE hDevice, int nChannel, int nOutputMode);
 int	 (COMILX_MC_GetOutputMode) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_SetInputMode) (HANDLE hDevice, int nChannel, int nInputMode, int nPulseLogic);
 void (COMILX_MC_GetInputMode) (HANDLE hDevice, int nChannel, int *pInputMode, int *pPulseLogic);
 void (COMILX_MC_SetSpeedRange) (HANDLE hDevice, int nChannel, double fMaxSpeed);
 void (COMILX_MC_GetSpeedRange) (HANDLE hDevice, int nChannel, double *fMinSpeed, double *fMaxSpeed);
 void (COMILX_MC_SetUnitDistance) (HANDLE hDevice, int nChannel, double fUnitDist);
 double (COMILX_MC_GetUnitDistance) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_SetUnitSpeed) (HANDLE hDevice, int nChannel, double fUnitSpeed);
 double (COMILX_MC_GetUnitSpeed) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_SetInOutRatio) (HANDLE hDevice, int nChannel, double fRatio);
 void (COMILX_MC_SetPosSrc) (HANDLE hDevice, int nChannel, int nSource);
 // Single Axis Motions //
 void (COMILX_MC_SetSpeedMode) (HANDLE hDevice, int nChannel, int nModeIndex);
 void (COMILX_MC_SetSpeed) (HANDLE hDevice, int nChannel, double fIniSpeed, double fWorkSpeed);
 void (COMILX_MC_SetAccel) (HANDLE hDevice, int nChannel, double fAccel, double fDecel);
 void (COMILX_MC_SetScurve) (HANDLE hDevice, int nChannel, double fSVacc, double fSVdec);
 void (COMILX_MC_StartVMove) (HANDLE hDevice, int nChannel, int nDirection);
 void (COMILX_MC_StartMove) (HANDLE hDevice, int nChannel, double fDistance);
 void (COMILX_MC_Move) (HANDLE hDevice, int nChannel, double fDistance);
 void (COMILX_MC_StartMoveTo) (HANDLE hDevice, int nChannel, double fPosition);
 void (COMILX_MC_MoveTo) (HANDLE hDevice, int nChannel, double fPosition);
 void (COMILX_MC_Stop) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_EmgStop) (HANDLE hDevice, int nChannel);
 int (COMILX_MC_Done) (HANDLE hDevice, int nChannel);
 // Multi-Axes Motion //
 void (COMILX_MC_StartVMoveAll) (HANDLE hDevice, int nNumAxis, int nAxisList[], int nDirList[]);
 void (COMILX_MC_StartMoveAll) (HANDLE hDevice, int nNumAxis, int nAxisList[], double fDistList[]);
 void (COMILX_MC_MoveAll) (HANDLE hDevice, int nNumAxis, int nAxisList[], double fDistList[]);
 void (COMILX_MC_StartMoveToAll) (HANDLE hDevice, int nNumAxis, int nAxisList[], double fPosList[]);
 void (COMILX_MC_MoveToAll) (HANDLE hDevice, int nNumAxis, int nAxisList[], double fPosList[]);
 void (COMILX_MC_StopAll) (HANDLE hDevice, int nNumAxis, int nAxisList[]);
 void (COMILX_MC_EmgStopAll) (HANDLE hDevice, int nNumAxis, int nAxisList[]);
 int (COMILX_MC_AllDone) (HANDLE hDevice, int nNumAxis, int nAxisList[]);
 // Coordinated Motion //
 int (COMILX_MC_MapAxes) (HANDLE hDevice, int nMapIndex, long bMapMask);
 void (COMILX_MC_SetSpeedModeMx) (HANDLE hDevice, int nMapIndex, int nModeIndex);
 void (COMILX_MC_SetSpeedMx) (HANDLE hDevice, int nMapIndex, double fSpeed, double fAccel);
 void (COMILX_MC_StartLine) (HANDLE hDevice, int nMapIndex, double fDistList[]);
 void (COMILX_MC_Line) (HANDLE hDevice, int nMapIndex, double fDistList[]);
 void (COMILX_MC_StartLineTo) (HANDLE hDevice, int nMapIndex, double fPosList[]);
 void (COMILX_MC_LineTo) (HANDLE hDevice, int nMapIndex, double fPosList[]);
 void (COMILX_MC_StartArc_a) (HANDLE hDevice, int nMapIndex, double fXCentOffset, double fYCentOffset, double fEndAngle);
 void (COMILX_MC_Arc_a) (HANDLE hDevice, int nMapIndex, double fXCentOffset, double fYCentOffset, double fEndAngle);
 void (COMILX_MC_StartArc_p) (HANDLE hDevice, int nMapIndex, double fXCentOffset, double fYCentOffset, double fXEndPointDist, double fYEndPointDist, int nDir);
 void (COMILX_MC_Arc_p) (HANDLE hDevice, int nMapIndex, double fXCentOffset, double fYCentOffset, double fXEndPointDist, double fYEndPointDist, int nDir);
 void (COMILX_MC_StartArcTo_a) (HANDLE hDevice, int nMapIndex, double fXCent, double fYCent, double fEndAngle);
 void (COMILX_MC_ArcTo_a) (HANDLE hDevice, int nMapIndex, double fXCent, double fYCent, double fEndAngle);
 void (COMILX_MC_StartArcTo_p) (HANDLE hDevice, int nMapIndex, double fXCent, double fYCent, double fXEndPos, double fYEndPos, int nDir);
 void (COMILX_MC_ArcTo_p) (HANDLE hDevice, int nMapIndex, double fXCent, double fYCent, double fXEndPos, double fYEndPos, int nDir);
 void (COMILX_MC_CompleteArc) (HANDLE hDevice, int nMapIndex);
 int (COMILX_MC_MxDone) (HANDLE hDevice, int nMapIndex);
 // Spline Interpolation //
 double* (COMILX_MC_BuildSpline) (double fInPoints[], int nNumInPoints, int nNumOutPoints);
 void (COMILX_MC_DeleteSpline) (double *pSplineBuffer);
 // Helical Interpolation //
 int (COMILX_MC_StartHelical) (HANDLE hDevice, THelicalUserInfo *pHelicalUserInfo);
 int (COMILX_MC_AbortHelical) (HANDLE hDevice);

 // Overriding //
 void (COMILX_MC_OverrideSpeedSet) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_OverrideSpeedSetAll) (HANDLE hDevice, int nNumAxis, int nAxisList[]);
 int (COMILX_MC_OverrideMove) (HANDLE hDevice, int nChannel, double fNewDistance);
 int (COMILX_MC_OverrideMoveTo) (HANDLE hDevice, int nChannel, double fNewPosition);
 // Home Move //
 void (COMILX_MC_SetHomeConfig) (HANDLE hDevice, int nChannel, int nOrgMode, int nOrgLogic, int nEzCount, int nEzLogic, int nErcOut);
 void (COMILX_MC_HomeMove) (HANDLE hDevice, int nChannel, int nDirection, double fRvsVel);
 
 // al Switch Move //
 void (COMILX_MC_StartVMoveEx) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_StartMoveEx) (HANDLE hDevice, int nChannel, double fDistance);
 // Pulser Mode //
 void (COMILX_MC_SetPulserInputMode) (HANDLE hDevice, int nChannel, int nInputMode, int bInverse);
 void (COMILX_MC_PulserHomeMove) (HANDLE hDevice, int nChannel, int nHomeType);
 void (COMILX_MC_StartPulserVMove) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_StartPulserMove) (HANDLE hDevice, int nChannel, double fDistance);
 void (COMILX_MC_PulserMove) (HANDLE hDevice, int nChannel, double fDistance);
 void (COMILX_MC_StartPulserMoveTo) (HANDLE hDevice, int nChannel, double fPosition);
 void (COMILX_MC_PulserMoveTo) (HANDLE hDevice, int nChannel, double fPosition);
 // List-Motion //
 void (COMILX_MC_SetListMotionAxes) (HANDLE hDevice, unsigned char bMapMask);
 void (COMILX_MC_BeginList) (HANDLE hDevice);
 void (COMILX_MC_EndList) (HANDLE hDevice);
 void (COMILX_MC_StartListMotion) (HANDLE hDevice);
 void (COMILX_MC_AbortListMotion) (HANDLE hDevice);
 int (COMILX_MC_CheckListMotionDone) (HANDLE hDevice);
 // Reset //
 void (COMILX_MC_ResetAxis) (HANDLE hDevice, int nChannel);
 // Get/Set Status //
 double (COMILX_MC_GetCurSpeed) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_EnableActSpdChk) (HANDLE hDevice, long dwInterval);
 void (COMILX_MC_DisableActSpdChk) (HANDLE hDevice);
 double (COMILX_MC_GetActualSpeed) (HANDLE hDevice, int nChannel);
 double (COMILX_MC_GetPosition_A) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_SetPosition_A) (HANDLE hDevice, int nChannel, double fActualPos);
 double (COMILX_MC_GetPosition_C) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_SetPosition_C) (HANDLE hDevice, int nChannel, double fPosition);
 long (COMILX_MC_GetCount_A) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_SetCount_A) (HANDLE hDevice, int nChannel, long nCount);
 long (COMILX_MC_GetCount_C) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_SetCount_C) (HANDLE hDevice, int nChannel, long nCount);
 long (COMILX_MC_GetCount_D) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_SetCount_D) (HANDLE hDevice, int nChannel, long nCount);
 long (COMILX_MC_GetCount_G) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_SetCount_G) (HANDLE hDevice, int nChannel, long nCount);
 long (COMILX_MC_GetCount_R) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_SetCount_R) (HANDLE hDevice, int nChannel, long nCount);
 long (COMILX_MC_ReadLatchCounter) (HANDLE hDevice, int nChannel, int nCounter);
 int (COMILX_MC_GetLatchState) (HANDLE hDevice, int nChannel);
 int (COMILX_MC_GetMotionStatus) (HANDLE hDevice, int nChannel);
 int (COMILX_MC_GetMioStatus) (HANDLE hDevice, int nChannel);
 // Set Config //
 void (COMILX_MC_SetFilterLogic) (HANDLE hDevice, int nChannel, int bEnable);
 void (COMILX_MC_SetPE) (HANDLE hDevice, int nChannel, int bEnable);
 void (COMILX_MC_SetELL) (HANDLE hDevice, int nChannel, int nLogic);
 void (COMILX_MC_SetMioCfgALM) (HANDLE hDevice, int nChannel, int nAlarmLogic, int nAlarmMode);
 void (COMILX_MC_GetMioCfgALM) (HANDLE hDevice, int nChannel, int *pAlarmLogic, int *pAlarmMode);
 void (COMILX_MC_SetMioCfgCLR) (HANDLE hDevice, int nChannel, int CntrSel, int nSignalType);
 void (COMILX_MC_GetMioCfgCLR) (HANDLE hDevice, int nChannel, int *pCntrSel, int *pnSignalType);
 void (COMILX_MC_SetMioCfgCMP) (HANDLE hDevice, int nChannel, unsigned long nCmpPulseWidth, int nCmpLogic);
 void (COMILX_MC_GetMioCfgCMP) (HANDLE hDevice, int nChannel, unsigned long *pnCmpPulseWidth, int *pnCmpLogic);
 void (COMILX_MC_SetMioCfgDR) (HANDLE hDevice, int nChannel, int nLogic);
 void (COMILX_MC_GetMioCfgDR) (HANDLE hDevice, int nChannel, int *pnLogic);
 void (COMILX_MC_SetMioCfgEL) (HANDLE hDevice, int nChannel, int nElMode);
 void (COMILX_MC_GetMioCfgEL) (HANDLE hDevice, int nChannel, int *pElMode);
 void (COMILX_MC_SetMioCfgERC) (HANDLE hDevice, int nChannel, int nErcLogic, int nErcOnTime);
 void (COMILX_MC_GetMioCfgERC) (HANDLE hDevice, int nChannel, int *pErcLogic, int *pErcOnTime);
 void (COMILX_MC_SetMioCfgLTC) (HANDLE hDevice, int nChannel, int nLtcLogic, int nLtc2Src);
 void (COMILX_MC_GetMioCfgLTC) (HANDLE hDevice, int nChannel, int *pnLtcLogic, int *pnLtc2Src);
 void (COMILX_MC_SetMioCfgINP) (HANDLE hDevice, int nChannel, int bInpEnable, int nInpLogic);
 void (COMILX_MC_GetMioCfgINP) (HANDLE hDevice, int nChannel, int *pInpEnable, int *pInpLogic);
 void (COMILX_MC_SetMioCfgSD) (HANDLE hDevice, int nChannel, int bSdEnable, int nSdLogic, int nSdLatch, int nSdMode);
 void (COMILX_MC_GetMioCfgSD) (HANDLE hDevice, int nChannel, int *pSdEnable, int *pSdLogic, int *pSdLatch, int *pSdMode);
 void (COMILX_MC_SetMioCfgSTA) (HANDLE hDevice, int nChannel, int nMode, int nInputType);
 void (COMILX_MC_SetMioCfgSTP) (HANDLE hDevice, int nChannel, int nMode);
 void (COMILX_MC_SetSoftLimit) (HANDLE hDevice, int nChannel, double fLimitP, double fLimitN);
 void (COMILX_MC_EnableSoftLimit) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_DisableSoftLimit) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_SetErrorCompare) (HANDLE hDevice, int nChannel, double fTol, int bEnable);
 void (COMILX_MC_SetGeneralCompare) (HANDLE hDevice, int nChannel, int nCmpSrc, int nCmpMethod, int nCmpAction, double fData);
 
 // Position Compare Output functions //
 void (COMILX_MC_SetTriggerCompare) (HANDLE hDevice, int nChannel, int nCmpSrc, int nCmpMethod, double fData);
 int (COMILX_MC_RegTableCCMP) (HANDLE hDevice, int nChannel, double *pDataBuffer, int nNumData);
 int (COMILX_MC_BuildTableCCMP) (HANDLE hDevice, int nChannel, double fStartData, double fInterval, int nNumData);
 int (COMILX_MC_StartCCMP) (HANDLE hDevice, int nChannel, int nCmpSrc, int nCmpMethod);
 int (COMILX_MC_StopCCMP) (HANDLE hDevice, int nChannel);
 int (COMILX_MC_CmpTrgIx_SetMap) (HANDLE hDevice, int nMapIdx, int nAxis_X, int nAxis_Y, int nDoChan);
 int (COMILX_MC_CmpTrgIx_GetMap) (HANDLE hDevice, int nMapIdx, int *pnAxis_X, int *pnAxis_Y, int *pnDoChan, int *pnIsValid);
 int (COMILX_MC_CmpTrgIx_SetCfg) (HANDLE hDevice, int nMapIdx, int nCmpSrc_X, int nCmpSrc_Y);
 int (COMILX_MC_CmpTrgIx_GetCfg) (HANDLE hDevice, int nMapIdx, int *pnCmpSrc_X, int *pnCmpSrc_Y);
 int (COMILX_MC_CmpTrgIx_Start) (HANDLE hDevice, int nMapIdx, int anSelOutList[], double afCmpPosList[], int anCmpDirList[], int nListSize);
 int (COMILX_MC_CmpTrgIx_Stop) (HANDLE hDevice, int nMapIdx);
 int (COMILX_MC_CmpTrgIx_GetState) (HANDLE hDevice, int nMapIdx, int *nCmpOutCnt, int *nIsActive);

 // Interrupt  //
 void (COMILX_MC_MaskInterrupt) (HANDLE hDevice, int nChannel, long dwMask);
 void (COMILX_MC_EnableInterrupt) (HANDLE hDevice, HANDLE hEvent);
 void (COMILX_MC_DisableInterrupt) (HANDLE hDevice);
 int (COMILX_MC_GetAxisIntState) (HANDLE hDevice, int nChannel);
 void (COMILX_MC_GetIntStatus) (HANDLE hDevice, int nChannel, long *pErrorStatus, long *pEventStatus);

 // New Added Functions (V3.1.0.0) //
 void (COMILX_MC_SetSpeedMx2) (HANDLE hDevice, int nMapIndex, double fSpeed, double fAccel, double fDecel);
 void (COMILX_MC_PutIntSTA) (HANDLE hDevice, int ChanMask);
 void (COMILX_MC_SetSyncMode) (HANDLE hDevice, int nChannel, int nMode, int nRefChan, int nCond);
 void (COMILX_MC_HomeMoveAuto) (HANDLE hDevice, int nChannel, int nDirection, 
									  double fRvsVel, double fEscapeDist);
 void (COMILX_MC_HomeMoveAutoAll) (HANDLE hDevice, int nNumAxis, int nAxisList[], int nDirList[],
									double fRvsVelList[], double fEscapeDistList[]);
 void (COMILX_MC_SetHelOnceSpeed) (HANDLE hDevice, int nMaster, int nSpeedMode, double fSpeed, 
											double fAcc, double fDec);
 double	(COMILX_MC_StartHelOnce) (HANDLE hDevice, int nNumAxis, int nAxisList[], double fCoordList[], double fArcAngle);
 double	(COMILX_MC_HelOnce) (HANDLE hDevice, int nNumAxis, int nAxisList[], double fCoordList[], double fArcAngle);
 int		(COMILX_MC_LmCurSequence) (HANDLE hDevice);
 void	(COMILX_MC_LmSetImmediacy) (HANDLE hDevice);
 void	(COMILX_MC_GetHomeConfig) (HANDLE hDevice, int nChannel, int *pnOrgMode, int *pnOrgLogic, int *pnEzCount, int *pnEzLogic, int *pnErcOut);
 int		(COMILX_MC_GetFilterLogic) (HANDLE hDevice, int nChannel, int *pbEnable);
 int	(COMILX_MC_GetPE) (HANDLE hDevice, int nChannel, int *pbEnable);
 int		(COMILX_MC_GetELL) (HANDLE hDevice, int nChannel, int *pnLogic);;
 void	(COMILX_MC_SetOutputMask) (HANDLE hDevice, int nChannel, int bMask);
 int	(COMILX_MC_GetOutputMask) (HANDLE hDevice, int nChannel);
 int		(COMILX_MC_InitFromFile) (HANDLE hDevice, char *szFilePath);
 double	(COMILX_MC_GetInOutRatio) (HANDLE hDevice, int nChannel);
 void	(COMILX_MC_GetMioCfgSTA) (HANDLE hDevice, int nChannel, int *pnMode, int *pnInputType);
 void	(COMILX_MC_GetMioCfgSTP) (HANDLE hDevice, int nChannel, int *pnMode);
 void	(COMILX_MC_GetSoftLimit) (HANDLE hDevice, int nChannel, double *pfLimitP, double *pfLimitN);
 int	(COMILX_MC_GetEnableSoftLimit) (HANDLE hDevice, int nChannel);
 void	(COMILX_MC_GetDeviceVer) (HANDLE hDevice, int *pnVerMajor, int *pnVerMinor);
 int		(COMILX_EnableDebugLog) (HANDLE hDevice, char *szLogFile, int nDebugLevel);
 void	(COMILX_MC_ReadAllRegs) (HANDLE hDevice, unsigned long lRegArray[][60]);

 void	(COMILX_MC_ErcOut) (HANDLE hDevice, int nChannel);
 void	(COMILX_MC_ErcReset) (HANDLE hDevice, int nChannel);
 int	(COMILX_MC_SetCorrection) (HANDLE hDevice, long nChannel, long CorrMode, double CorrAmount, double CorrVel, long CntrMask);

 void	(COMILX_MC_LmDoPutOne) (HANDLE hDevice, HANDLE hDoDevice, int nChannel, int nOutState);
 void	(COMILX_MC_LmDoPutMulti) (HANDLE hDevice, HANDLE hDoDevice, int nChannelGroup,
										int dwMask, int dwOutStatess);
 void	(COMILX_MC_LmDoPulseOne) (HANDLE hDevice, HANDLE hDoDevice, int nChannel, int nOutState, unsigned long dwDueTime);
 void	(COMILX_MC_LmDoPulseMulti) (HANDLE hDevice, HANDLE hDoDevice, int nChannelGroup,
										int dwMask, int dwOutStatess, unsigned long dwDueTime);

 // New Added Functions (V3.1.5.0) //
 void	(COMILX_MC_SetMioProperty) (HANDLE hDevice, int nChannel, long lPropId, long lPropVal);
 void	(COMILX_MC_GetMioProperty) (HANDLE hDevice, int nChannel, long lPropId, long *plPropVal);

 //__________ Utility Functions ____________________________________________//
 int		(COMILX_LastError) (void);
 const char* (COMILX_ErrorString) (int nErrCode);
 int	(COMILX_GetAvailDevList) (TComiDevList *pDevList);
 int	(COMILX_GetDevInfo) (HANDLE hDevice, TComiDevInfo *pDevInfo);
 void 	(COMILX_GetResources) (HANDLE hDevice, unsigned long *pdwIntVect, unsigned long *pdwIoPorts,
					 int nNumPorts, unsigned long *pdwMemPorts, int nNumMemPorts);
  void	(COMILX_WriteMemPortDW) (HANDLE hDevice, unsigned long dwPortBase, unsigned long nOffset, unsigned long dwOutVal);
  unsigned long	(COMILX_ReadMemPortDW) (HANDLE hDevice, unsigned long dwPortBase, unsigned long nOffset);
  void	(COMILX_Outpdw) (HANDLE hDevice, int CS_idx, unsigned long nOffset, unsigned long dwOutVal);
  unsigned long	(COMILX_Inpdw) (HANDLE hDevice, int CS_idx, unsigned long nOffset);
  void	(COMILX_Write8402) (HANDLE hDevice, int ch, int addr, int data);
  void	(COMILX_WriteEEPR) (HANDLE hDevice, int addr, int data);
  int		(COMILX_ReadEEPR) (HANDLE hDevice, int addr);
  unsigned long	(COMILX_MC_ReadMainSpace) (HANDLE hDevice, int nChannel, int nAddr);
  void	(COMILX_MC_WriteMainSpace) (HANDLE hDevice, int nChannel, int nAddr, unsigned long dwValue);
  unsigned long	(COMILX_MC_ReadRegister) (HANDLE hDevice, int nChannel, int nRegister);
  void	(COMILX_MC_WriteRegister) (HANDLE hDevice, int nChannel, int nRegister, unsigned long dwValue);
  int		(COMILX_GetDeviceThreadCount) (HANDLE hDevice);